import { ipcMain } from 'electron'

export const toggleAlwaysOnTop = win => {
  if (win) {
    ipcMain.emit('window-toggle-always-on-top', win)
  }
}

export const zoomIn = win => {
  const { webContents } = win
  const zoom = webContents.getZoomFactor()
  // WORKAROUND: We need to set zoom on the browser window due to Electron#16018.
  webContents.send('mt::window-zoom', Math.min(2.0, zoom + 0.125))
}

export const zoomOut = win => {
  const { webContents } = win
  const zoom = webContents.getZoomFactor()
  // WORKAROUND: We need to set zoom on the browser window due to Electron#16018.
  webContents.send('mt::window-zoom', Math.max(1.0, zoom - 0.125))
}
